13.异常

tech2022-08-07  1

异常

1.定义

java编程语言使用异常处理机制为程序提供了错误处理的能力,程序出现错误,程序安全退出的机制。

java是采用面向对象的方式来处理异常的。处理过程:

抛出异常:在执行一个方法时,如果发生异常,则这个方法生成代表该异常的一个对象,停止当前执行 路径,并把异常对象提交给jre。

捕获异常:jre得到该异常后,寻找相应的代码来处理该异常。jre在方法的调用栈中查找,从生成异 常的方法开始回溯,直到找到相应的异常处理代码为止。

2.异常继承关系图:

error:是程序无法处理的错误,表示运行应用程序中比较严重的错误,大多数错误与代码编写者执行的操作无关,而表示代码运行时JVM出现的问题,例如:java虚拟机运行错误,当jvm不再继续执行操作所需的内存资源时,将出现OutofMemoryError。这些异常发生时,java虚拟机一般会线程程序终止。

Error表明系统jvm已经处于不可恢复的奔溃状态中。我们不需要管它。

Exception是程序本身能够处理的异常,如空指针异常(NullPointerException)、数组越界(ArrayIndexOutOfBoundsException)、类型转换异常(ClassCastException)、算术异常(ArithmeticException)等。

Exception类是所有异常的父类,其子类对应了各种各样可能出现的异常事件。通常java的异常课分为:

RuntimeException 运行时异常CheckException 检查异常。

3.常见异常说明

异 常 类 型说 明说 明Exception异常层次结构的父类ArithmeticException算术错误情形,如以零作除数ArrayIndexOutOfBoundsException数组下标越界NullPointerException尝试访问 null 对象成员ClassNotFoundException找不到类IllegalArgumentException方法接收到非法参数ClassCastException对象强制类型转换出错NumberFormatException数字格式转换异常,如把"abc"转换成数字

4.RuntimeException异常

派生于RuntimeException的异常,如被0整除、数组下标越界、空指针等,其产生比较频繁,处理麻烦,如果显式的声明或捕获异常将会对程序可读性和运行效率影响很大。因此由系统自动检测并将他们交给缺省的异常处理程序(用户不必对其处理)。

这类异常通常是由编程错误导致的,所以在编写程序时,并不要求必须使用异常处理机制来处理这类异常,经常需要通过增加“逻辑处理来避免这些异常”。

示例

int a = 0; System.out.print(1/a);//报错

解决如上问题可以逻辑判断:如下

int a=0; if(a!=0){ System.out.print(1/a); }

案例

import java.util.InputMismatchException; import java.util.Scanner; public class Test1 { public static void main(String[] args) { Scanner input = new Scanner(System.in); try { System.out.println("请输入除数:"); int num1 = input.nextInt(); System.out.println("请输入被除数:"); int num2 = input.nextInt(); System.out.println(String.format("%d/%d=%d", num1,num2,num1/num2)); } catch (InputMismatchException e) { // TODO: handle exception System.err.println("出现错误,除数和被除数必须是整数"); e.printStackTrace();//把错误信息打印出来 }catch(ArithmeticException e) { System.out.println("出现错误,被除数不能为零"); System.out.println("错误信息:"+e.getMessage()); // System.exit(1);//程序退出不执行finally // return;//先执行finally再去执行return }catch(Exception e) { System.out.println("出现错误,发生其他异常"); e.printStackTrace(); }finally { //finally代码块不管程序是否发生异常,都会执行finally代码块 //一般用于资源的释放 System.out.println("运算结束"); } } }

5.throws声明异常

throws用于定义方法的时候声明异常告诉你调用这个方法`的时候可能会发生那些异常测试 import java.util.InputMismatchException; import java.util.Scanner; public class Test { //throws用于定义方法的时候声明异常 //告诉你调用这个方法`的时候可能会发生那些异常 // public static void divide() throws InputMismatchException,ArithmeticException { public static void divide() throws Exception { Scanner input = new Scanner(System.in); System.out.println("请输入除数:"); int num1 = input.nextInt(); System.out.println("请输入被除数:"); int num2 = input.nextInt(); System.out.println(String.format("%d/%d=%d", num1,num2,num1/num2)); } //调用声明了异常的方式1,继续声明异常 // public static void main(String[] args) throws InputMismatchException{ // Test.divide(); // } public static void main(String[] args) throws InputMismatchException{ //调用声明异常的方法,就要做出异常的处理,要不捕获异常,要不就继续在main方法声明异常,直到调用main方法的方法去处理 try { Test.divide(); } catch (Exception e) { // TODO: handle exception e.printStackTrace(); } } }

6.throw抛出异常

测试:通过throw抛出异常信息来提示输入的性别

创建Student类

public class Student { String name; int age; char sex; public char getSex() { return sex; } public void setSex(char sex) throws Exception{ if(sex=='男'||sex=='女') { this.sex = sex; }else { //throw是抛出异常信息 throw new Exception("性别只能是男或女!"); } } public String getName() { return name; } public void setName(String name) { this.name = name; } public int getAge() { return age; } public void setAge(int age) { this.age = age; } }

测试

public class Test { public static void main(String[] args) throws Exception { Student student = new Student(); student.setSex('公'); } }

当传入’公’时报错

Exception in thread "main" java.lang.Exception: 性别只能是男或女! at day03.Student.setSex(Student.java:16) at day03.Test.main(Test.java:7)

7.CheckException编译时异常

所有不是RuntimeException的异常,统称为Checked Exception,又被称为"已检查异常",如IOException、SQL Exception等以及用户自定义的Exception异常。这类异常在编译时就必须做出处理,否则无法通过编译。 import java.io.FileInputStream; import java.io.FileNotFoundException; import java.io.IOException; import java.io.InputStream; /** * FileInputExcption是检查时异常,必须处理 * RuntimeExcption可以不处理 * @author Administrator * */ public class Test { public static void main(String[] args) { InputStream is=null; try { is = new FileInputStream("D:\\wu.txt"); char c1 = (char)is.read(); System.out.println("打印"+c1); } catch (FileNotFoundException e) { // TODO Auto-generated catch block e.printStackTrace(); } catch (IOException e) { // TODO Auto-generated catch block e.printStackTrace(); }finally { if(is!=null) { try { is.close(); } catch (IOException e) { // TODO Auto-generated catch block e.printStackTrace(); } } } } }

8.自定义异常

在程序中,可能会遇到jdk提供的任何标准异常类都无法充分描述清楚我们想要表达的问题,这种情况下可以创建自己的异常类,即自定义异常类。

自定义异常只需从Exception类或者它的子类派生一个子类即可。

自定义异常类如果继承Exception类,即为受检查异常,必须对其进行处理,如果不想处理,可以让自定义异常类继承运行时异RuntimeException类。

习惯上,自定义异常类应该包含2个构造器,一个是默认的构造器,另一个是带有详细信息的构造器。

测试:自定义判断输入年龄的异常

创建自定义异常类IllegaAgeException

public class IllegaAgeException extends Exception { public illegaAgeException() {} public illegaAgeException(String massage) { super(massage); } }

在person类中使用

public class Person { private int age; public int getAge() { return age; } public void setAge(int age) throws illegaAgeException { if(age<0) { throw new illegaAgeException("年龄不能为负数"); }else { this.age = age; } } }

测试

public class Test { public static void main(String[] args) { Person per = new Person(); try { per.setAge(-21); } catch (illegaAgeException e) { // TODO Auto-generated catch block e.printStackTrace(); } } }

当传入的年龄小于0时报错

day05.illegaAgeException: 年龄不能为负数 at day05.Person.setAge(Person.java:12) at day05.Test.main(Test.java:7)

9.面试题

1. final与finally的区别

final修饰的变量叫常亮,值是不可以被修改的,并且需要赋初始值。

final修饰的方法不能重写

final修饰的类不能被继承

局部常量可以不赋初始值

finally代码块不管程序是否发生异常,都会执行finally代码块,一般用于资源的释放

2.什么情况下finally不执行

ystem.exit(1);//程序退出,不执行finally

3. throw与throws的区别

throw是抛出异常信息throws是在方法中声明异常,通俗讲就是定义这个方法的时候告诉调用者调用该方法的时候可能会发生异 常,调用者要不try-catch捕获异常,要不不管继续声明往上传递,直到上面的方法捕捉。

10.异常处理机制

要避免使用异常处理代替错误处理,这样会降低程序的清晰性,并且效率低下

处理异常不可以代替简单测试----只在异常情况下使用异常机制

不要进行小粒度的异常处理----应该将整个任务包装在一个try语句块中

异常往往在高层处理(先了解,后期做项目会讲)